"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const apollo_server_core_1 = require("apollo-server-core");
const iterall_1 = require("iterall");
function graphqlExpress(options) {
    if (!options) {
        throw new Error('Apollo Server requires options.');
    }
    if (arguments.length > 1) {
        throw new Error(`Apollo Server expects exactly one argument, got ${arguments.length}`);
    }
    const graphqlHandler = (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        const a = apollo_server_core_1.runHttpQuery([req, res], {
            method: req.method,
            options: options,
            query: req.method === 'POST' ? req.body : req.query,
            request: apollo_server_core_1.convertNodeHttpToRequest(req),
        }).then(({ graphqlResponse, graphqlResponses, responseInit }) => __awaiter(this, void 0, void 0, function* () {
            Object.keys(responseInit.headers).forEach(key => res.setHeader(key, responseInit.headers[key]));
            if (graphqlResponse) {
                res.setHeader('Content-Length', Buffer.byteLength(graphqlResponse, 'utf8').toString());
                res.write(graphqlResponse);
                res.end();
            }
            else if (graphqlResponses) {
                res.setHeader('Content-Type', 'multipart/mixed; boundary="-"');
                yield iterall_1.forAwaitEach(graphqlResponses, data => {
                    res.write(data + '\r\n---\r\n');
                });
                res.write('\r\n---');
                res.end();
            }
        }), (error) => {
            if ('HttpQueryError' !== error.name) {
                return next(error);
            }
            if (error.headers) {
                Object.keys(error.headers).forEach(header => {
                    res.setHeader(header, error.headers[header]);
                });
            }
            res.statusCode = error.statusCode;
            res.write(error.message);
            res.end();
        });
    });
    return graphqlHandler;
}
exports.graphqlExpress = graphqlExpress;
//# sourceMappingURL=expressApollo.js.map